<?php

require 'functions.php';

$info = [];
$info['success'] = false;

if($_SERVER['REQUEST_METHOD'] == "POST" && !empty($_POST['data_type']))
{

	$info['data_type'] = $_POST['data_type'];
	if($_POST['data_type'] == 'add_record')
	{
		$errors = [];
		$email 		= addslashes($_POST['email']);
		$first_name = addslashes($_POST['first_name']);
		$last_name 	= addslashes($_POST['last_name']);
		$comment 	= addslashes($_POST['comment']);
		$address 	= addslashes($_POST['address']);
		$image 		= "";
		$gender 	= addslashes($_POST['gender']);
		$phone 		= addslashes($_POST['phone']);
		$date 		= date("Y-m-d H:i:s");

		if(!filter_var($email, FILTER_VALIDATE_EMAIL)){

			$errors['email'] = "Invalid email";
		}

		if(!preg_match("/^[a-zA-Z ]+$/", $first_name)){

			$errors['first_name'] = "First name can only have letters and spaces";
		}

		if(!preg_match("/^[a-zA-Z ]+$/", $last_name)){

			$errors['last_name'] = "Last name can only have letters and spaces";
		}

		if(!empty($_FILES['image']['name']))
		{
			$allowed = ['image/jpeg','image/png','image/gif','image/webp'];
			if(in_array($_FILES['image']['type'], $allowed))
			{
				$folder = 'uploads/';
				if(!file_exists($folder))
				{
					mkdir($folder,0777,true);
				}

				$image = $folder . $_FILES['image']['name'];
				move_uploaded_file($_FILES['image']['tmp_name'], $image);
			}else{
				$errors['image'] = "Invalid image format";
			}
		}
		

		if(empty($errors))
		{
			//save to database

			if(empty($_POST['id']))
			{
				$query = "insert into employees (first_name,last_name,email,phone,gender,address,comment,date,image) 
				values ('$first_name','$last_name','$email','$phone','$gender','$address','$comment','$date','$image')";
				
			}else{

				$id = addslashes($_POST['id']);

				$image_string = "";
				if(!empty($image))
					$image_string = ",image = '$image'";

				$query = "update employees set first_name = '$first_name', last_name = '$last_name', email = '$email', phone = '$phone', gender = '$gender', address = '$address', comment = '$comment', date = '$date' $image_string
				 where id = '$id' limit 1";
			}
			query($query);

			$info['success'] = true;
			$info['message'] = "Record saved successfully!";
		}else{

			$info['message'] = "Please fix the errors!";
			$info['errors'] = $errors;
		}

	}else
	if($_POST['data_type'] == 'delete_record')
	{
		$id = addslashes($_POST['id']);
		
		$query = "delete from employees where id = '$id' limit 1";
		query($query);

		$info['success'] = true;
		$info['message'] = "Record deleted successfully!";
	}
}

echo json_encode($info);
